Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# Modules/ImageProcessor/ImageProcessorTools/SegmentationTools.h File Reference

Declaration of file SegmentationTools. More...

`#include "Tools/Math/Geometry.h"`
`#include "Tools/Math/Vector2.h"`
`#include "Tools/ColorClasses.h"`
`#include "MSH2004EdgeDetection.h"`

Include dependency graph for SegmentationTools.h:

Go to the source code of this file.

## Classes
class | listed
struct | figure
class | edge
struct | LinePair2
class | horLinePair2
struct | extLinePair2
struct | coloredLinePair2
struct | coloredHorLinePair2
class | slist
class | slist::iterator
struct | lineOnField
## Typedefs
typedef Vector2< int > | point
typedef Vector2< double > | direction
## Functions
point | mil (point &v1, point &v2)
bool | DoubleScanLinesNumber (slist< figure > &lst, MSH2004EdgeDetection &edgeScanner)
figure * | getMin (figure *lp)
void | createLinearSegment (slist< figure > &lst)
double | theta2 (point v1, point v2)
| Gives a number between 0 and 360 with the same order as v.angle().
double | theta2 (lineOnField *l1, lineOnField *l2)
double | AngleRelativeToHorizontal (const point &pt1, const point &pt2)

## Detailed Description

Declaration of file SegmentationTools.

Author:
  Damien DEOM

Definition in file SegmentationTools.h.

## Typedef Documentation

typedef Vector2<int> point

| Definition at line 19 of file SegmentationTools.h. Referenced by VLCGoalRecognizer::EdgePointList::add(), GT2005GoalRecognizer::EdgePointList::add(), SlamEdgeSpecialist::addCandidate(), GT2005EdgeSpecialist::addCandidate(), VLCImageProcessor::calcEdgeAngle(), SlamImageProcessor::calcEdgeAngle(), GT2005ImageProcessor::calcEdgeAngle(), Geometry::calculateAnglesForPoint(), Geometry::calculatePointByAngles(), Geometry::calculatePointInImage(), SlamEdgeSpecialist::checkPoint(), GT2005EdgeSpecialist::checkPoint(), Geometry::clipLineWithQuadrangle(), Geometry::clipPointInsideRectange(), ImageInfo::clipToImageBoundary(), Geometry::cohenSutherlandOutCode(), LinesTables2005::ObservationTable< xSize, ySize, cellSize, pointRes >::create(), ObservationTable< 320, 240, 25, 25 >::create(), GT2005PlayerSpecialist::detectBlueRobots(), GT2005PlayerSpecialist::detectRedRobots(), DoubleScanLinesNumber(), SlamSelfLocator::draw(), LinesTables2005::ObservationTable< xSize, ySize, cellSize, pointRes >::draw(), ObservationTable< 320, 240, 25, 25 >::draw(), GT2005StableSelfLocator::draw(), GT2004SelfLocator::draw(), GT2004SelfLocator::generatePoseTemplates(), SlamSampleTemplateGenerator::generateTemplates(), GT2005StableSampleTemplateGenerator::generateTemplates(), SlamLineCrossingsTable::getClassifiedClosestPoint(), GT2005StableLineCrossingsTable::getClassifiedClosestPoint(), SlamLineCrossingsTable::getClosestPoint(), LinesTables2005::ObservationTable< xSize, ySize, cellSize, pointRes >::getClosestPoint(), ObservationTable< 320, 240, 25, 25 >::getClosestPoint(), GT2005StableLineCrossingsTable::getClosestPoint(), GT2005LineCrossingsTable::getClosestPoint(), SlamSelfLocator::getCrossingClassification(), GT2005StableSelfLocator::getCrossingClassification(), ObstaclesModel::getDistanceInCorridor(), Geometry::getDistanceToEdge(), Geometry::getDistanceToLine(), Geometry::getIntersectionPointsOfLineAndRectangle(), VLCGoalRecognizer::EdgeDetector::getLastPointInClass(), GT2005GoalRecognizer::EdgeDetector::getLastPointInClass(), FutureWorldModelGenerator::getMaxRotationForObject(), Polygon::getPoints(), MotionRatingBehaviorControl::gotoPoint(), GT2005BasicBehaviorGoForwardToPoint::GT2005BasicBehaviorGoForwardToPoint(), GT2005BasicBehaviorGoToInterceptionPoint::GT2005BasicBehaviorGoToInterceptionPoint(), GT2005BasicBehaviorGoToPoint::GT2005BasicBehaviorGoToPoint(), GT2005BasicBehaviorGoToPointAndAvoidObstacles::GT2005BasicBehaviorGoToPointAndAvoidObstacles(), GT2005BasicBehaviorGoToPointFast::GT2005BasicBehaviorGoToPointFast(), GT2005BasicBehaviorGoToRelativePoint::GT2005BasicBehaviorGoToRelativePoint(), GT2005BasicBehaviorTurnAroundPoint::GT2005BasicBehaviorTurnAroundPoint(), GT2005BasicBehaviorTurnAroundPointFast::GT2005BasicBehaviorTurnAroundPointFast(), GT2005BasicBehaviorTurnAroundPointWithRadius::GT2005BasicBehaviorTurnAroundPointWithRadius(), horLinePair2::horLinePair2(), VLCGoalRecognizer::inspectNeighbourhood(), GT2005GoalRecognizer::inspectNeighbourhood(), VLCGoalRecognizer::inspectPixel(), VLCGoalRecognizer::EdgeDetector::inspectPixel(), GT2005GoalRecognizer::inspectPixel(), GT2005GoalRecognizer::EdgeDetector::inspectPixel(), Geometry::isPointInsideRectangle(), mil(), VLCGoalRecognizer::nearImageBorder(), GT2005GoalRecognizer::nearImageBorder(), Pose3D::operator *(), Pose2D::operator *(), GT2005ImageProcessor::pixelBelowHorizon(), lineOnField::pt1(), extLinePair2::pt1(), horLinePair2::pt1(), lineOnField::pt2(), extLinePair2::pt2(), horLinePair2::pt2(), LinesTables2005::ObservationTable< xSize, ySize, cellSize, pointRes >::read(), ObservationTable< 320, 240, 25, 25 >::read(), SlamImageProcessor::scan(), extLinePair2::toConsider(), horLinePair2::toConsider(), edge::toConsider(), SlamSelfLocator::updateByCenterCircle(), GT2005StableSelfLocator::updateByCenterCircle(), GT2005SelfLocator::updateByCenterCircle(), SlamSelfLocator::updateByCrossing(), GT2005StableSelfLocator::updateByCrossing(), GT2005SelfLocator::updateByCrossing(), SlamSelfLocator::updateByPoint(), GT2005StableSelfLocator::updateByPoint(), GT2005SelfLocator::updateByPoint(), GT2004SelfLocator::updateByPoint(), GT2005LineCrossingsTable::updateClosestPoint(), LinesTables2005::ObservationTable< xSize, ySize, cellSize, pointRes >::write(), and ObservationTable< 320, 240, 25, 25 >::write().

typedef Vector2<double> direction

| Definition at line 21 of file SegmentationTools.h. Referenced by VLCLineFinder_DeterministicApproach::findIntersections(), SlamBorderFinder::findIntersections(), GT2005LineFinder_DeterministicApproach::findIntersections(), extLinePair2::getDirection(), horLinePair2::getDirection(), Geometry::Line::Line(), Geometry::Line::normalizeDirection(), and GT2005HeadControl::setJoints().

## Function Documentation

point mil | ( | point & | v1,
|  | point & | v2
| ) | `[inline]`

| Definition at line 23 of file SegmentationTools.h. References point, Vector2< V >::x, and Vector2< V >::y. Referenced by extLinePair2::extLinePair2().

bool DoubleScanLinesNumber | ( | slist< figure > & | lst,
|  | MSH2004EdgeDetection & | edgeScanner
| ) | `[inline]`

| Definition at line 343 of file SegmentationTools.h. References DOT, slist< T >::front(), listed< figure >::getNext(), slist< T >::getSize(), slist< T >::incSize(), slist< T >::insert(), LINE, point, extLinePair2::pt1(), LinePair2::pt1(), extLinePair2::pt2(), LinePair2::pt2(), MSH2004EdgeDetection::scanEast(), MSH2004EdgeDetection::scanWest(), MSH2004EdgeDetection::threshold, Vector2< V >::x, and Vector2< V >::y.

Here is the call graph for this function:

figure* getMin | ( | figure * | lp | ) | `[inline]`

| Definition at line 407 of file SegmentationTools.h. References Geometry::distance(), figure::getId(), listed< figure >::getNext(), min, and figure::toConsider(). Referenced by createLinearSegment().

Here is the call graph for this function:

void createLinearSegment | ( | slist< figure > & | lst | ) | `[inline]`

| Definition at line 436 of file SegmentationTools.h. References slist< T >::front(), getMin(), slist< T >::getSize(), and min.

Here is the call graph for this function:

double theta2 | ( | point | v1,
|  | point | v2
| ) | `[inline]`

| Gives a number between 0 and 360 with the same order as v.angle(). Definition at line 472 of file SegmentationTools.h. References Vector2< V >::x, and Vector2< V >::y.

double theta2 | ( | lineOnField * | l1,
|  | lineOnField * | l2
| ) | `[inline]`

| Definition at line 485 of file SegmentationTools.h. References lineOnField::pt1(), and lineOnField::pt2().

Here is the call graph for this function:

double AngleRelativeToHorizontal | ( | const point & | pt1,
|  | const point & | pt2
| ) | `[inline]`

| Definition at line 496 of file SegmentationTools.h. References Vector2< V >::x.